#!/usr/bin/python

'''
Created on 4 june 2013

@author: karli.sjoberg@slu.se

version: 1.0
comment: This is the script that takes care of destroying a machine when it's not wanted any more.
'''

import cgi
form = cgi.FieldStorage()
CUSTOMER_ID = form.getvalue('userid')
VM_NAME = form.getvalue('vmname')
import socket
import logging
logging.basicConfig(filename='/var/log/vpscreate.log', format='%(asctime)s: %(message)s', level=logging.DEBUG)
from kira.api import DestroyClass

if __name__ == '__main__':

    dc = DestroyClass()

    HOSTNAME = dc.GetHostname(VM_NAME)

    try:
        socket.gethostbyname('%s.foo.bar' % (VM_NAME))
        logging.debug('Alias "%s.foo.bar" is registered in DNS. Sending de-registration' % (VM_NAME))
        dc.SendAliasDeregistration(CUSTOMER_ID, VM_NAME, HOSTNAME)
    except Exception as e:
        logging.debug('Alias "%s.foo.bar" is not registered in DNS. Proceeding' % (VM_NAME.lower()))
    
    dc.RemoveOwner(CUSTOMER_ID, HOSTNAME, VM_NAME)
    dc.deleteVM(VM_NAME)
    dc.SendDeleteSuccess(CUSTOMER_ID, VM_NAME, HOSTNAME)
    CODE = '2'
    dc.PrintDeleteSuccess(CODE)
    logging.debug('VPS Deletion sequence complete for user "%s" on VM "%s"' % (CUSTOMER_ID,VM_NAME))
