#!/usr/bin/python

'''
Created on 13 may 2013

@author: karli.sjoberg@slu.se

version: 1.0
comment: This is the script that reacts to user input from the orderportal and is responsible for deciding logics.
'''

import cgi
form = cgi.FieldStorage()
CUSTOMER_ID = form.getvalue('userid')
TEMPLATE_NAME = form.getvalue('template')
VM_NAME = form.getvalue('vmname')
import socket
import logging
logging.basicConfig(filename='/var/log/vpscreate.log', format='%(asctime)s: %(message)s', level=logging.DEBUG)
from kira.api import CreateClass
from kira.api import CLUSTER_NAME
from kira.api import SNAPSHOT_NAME
from kira.api import ROLE_NAME
from kira.api import DOMAIN_NAME
from kira.api import api

if __name__ == '__main__':
    
    cc = CreateClass()

    logging.debug('VPS Creation sequence started for user "%s" on VM "%s"' % (CUSTOMER_ID,VM_NAME))

    if TEMPLATE_NAME == None:
        logging.debug('Error: Variable "TEMPLATE_NAME" was empty')
        ERRORCODE = '0'
        cc.PrintError(VM_NAME,CUSTOMER_ID,ERRORCODE)
        exit(1)
    elif CUSTOMER_ID == None:
        logging.debug('Error: Variable "CUSTOMER_ID" was empty')
        ERRORCODE = '1'
        cc.PrintError(VM_NAME,CUSTOMER_ID,ERRORCODE)
        exit(1)
    elif VM_NAME == None:
        logging.debug('Error: Variable "VM_NAME" was empty')
        ERRORCODE = '2'
        cc.PrintError(VM_NAME,CUSTOMER_ID,ERRORCODE)
        exit(1)

    try:
        socket.gethostbyname('%s.foo.bar' % (VM_NAME.lower()))
        logging.debug('User "%s" failed to create VM: Alias "%s.foo.bar" is already registered in DNS' % (CUSTOMER_ID,VM_NAME.lower()))
        ERRORCODE = '3'
        cc.PrintError(VM_NAME,CUSTOMER_ID,ERRORCODE)
        exit(1)
    except Exception as e:
        logging.debug('Alias "%s.foo.bar" is not registered in DNS. Proceeding' % (VM_NAME.lower()))

    if api.vms.list(VM_NAME):
        logging.debug('User "%s" failed to create VM: VM name "%s" is already registered in oVirt' % (CUSTOMER_ID,VM_NAME))
        ERRORCODE = '4'
        cc.PrintError(VM_NAME,CUSTOMER_ID,ERRORCODE)
        exit(1)
    elif api.vms.list(VM_NAME.lower()):
        logging.debug('User "%s" failed to create VM: VM name "%s" is already registered in oVirt' % (CUSTOMER_ID,VM_NAME.lower()))
        ERRORCODE = '4'
        cc.PrintError(VM_NAME,CUSTOMER_ID,ERRORCODE)
        exit(1)
    elif api.vms.list(VM_NAME.upper()):
        logging.debug('User "%s" failed to create VM: VM name "%s" is already registered in oVirt' % (CUSTOMER_ID,VM_NAME.upper()))
        ERRORCODE = '4'
        cc.PrintError(VM_NAME,CUSTOMER_ID,ERRORCODE)
        exit(1)

    logging.debug('VM name "%s" is not registered in oVirt. Proceeding' % (VM_NAME))
    VM_NAME = VM_NAME.lower()
    cc.CreateVM(VM_NAME, CLUSTER_NAME, TEMPLATE_NAME)
    cc.CreateSnapshot(VM_NAME, SNAPSHOT_NAME)
    if api.users.list(CUSTOMER_ID):
        cc.SetPermissions(VM_NAME, CUSTOMER_ID, ROLE_NAME)
    else:
        cc.CreateUser(CUSTOMER_ID, DOMAIN_NAME)
        cc.SetPermissions(VM_NAME, CUSTOMER_ID, ROLE_NAME)
    HOSTNAME = cc.GetHostname(VM_NAME)
    cc.SetOwner(CUSTOMER_ID, HOSTNAME, VM_NAME)
    cc.StartVM(VM_NAME)
    cc.SendAliasRegistration(CUSTOMER_ID, VM_NAME, HOSTNAME)
    cc.SendConfirmation(CUSTOMER_ID, VM_NAME, HOSTNAME)
    cc.PrintSuccess()
    logging.debug('VPS Creation sequence complete for user "%s" on VM "%s"' % (CUSTOMER_ID,VM_NAME))
