#!/usr/bin/python

'''
Created on 3 june 2013

@author: karli.sjoberg@slu.se

version: 1.0
comment: This is the script that checks the validity of the removal process and send out a confirmation email to the user.
'''

import cgi
form = cgi.FieldStorage()
CUSTOMER_ID = form.getvalue('userid')
VM_NAME = form.getvalue('vmname')
import logging
logging.basicConfig(filename='/var/log/vpscreate.log', format='%(asctime)s: %(message)s', level=logging.DEBUG)
from kira.api import DestroyClass
from kira.api import api

if __name__ == '__main__':
    
    dc = DestroyClass()

    logging.debug('VPS Deletion sequence started for user "%s" on VM "%s"' % (CUSTOMER_ID,VM_NAME))
    
    if CUSTOMER_ID == None:
        logging.debug('Error: Variable "CUSTOMER_ID" was empty')
        ERRORCODE = '1'
        dc.PrintError(VM_NAME,CUSTOMER_ID,ERRORCODE)
        exit(1)
    elif VM_NAME == None:
        logging.debug('Error: Variable "VM_NAME" was empty')
        ERRORCODE = '2'
        dc.PrintError(VM_NAME,CUSTOMER_ID,ERRORCODE)
        exit(1)
    elif not api.vms.get(VM_NAME):
        if not api.vms.get(VM_NAME.lower()):
            logging.debug('Error: VM "%s" does not exist' % (VM_NAME.lower()))
            ERRORCODE = '3'
            dc.PrintError(VM_NAME,CUSTOMER_ID,ERRORCODE)
            exit(1)
        else:
            VM_NAME = VM_NAME.lower()

    try:
        if not api.users.list(query='usrname=%s*' % (CUSTOMER_ID)):
            logging.debug('Failed to look up user name "%s"' % (CUSTOMER_ID))
            ERRORCODE = '4'
            dc.PrintError(VM_NAME,CUSTOMER_ID,ERRORCODE)
    except Exception as e:
        logging.debug('Unhandled exception:\n%s' % str(e))

    if api.vms.get(VM_NAME).permissions.list()[0].get_user().get_id() == api.users.list(query='usrname=%s*' % (CUSTOMER_ID))[0].get_id():
        logging.debug('User "%s" is owner of VM "%s". Proceeding' % (CUSTOMER_ID,VM_NAME))
    else:
        logging.debug('User "%s" is not owner of VM "%s". Aborting' % (CUSTOMER_ID,VM_NAME))
        ERRORCODE = '5'
        dc.PrintError(VM_NAME,CUSTOMER_ID,ERRORCODE)
        exit(1)

    HOSTNAME = dc.GetHostname(VM_NAME)
    dc.SendDeleteConfirmation(CUSTOMER_ID, VM_NAME, HOSTNAME)
    CODE = '1'
    dc.PrintDeleteSuccess(CODE)
